import com.kinetica.*;

public class UdfSosJavaProc {
    public static void main(String[] args) {

        ProcData procData = ProcData.get();

        ProcData.InputDataSet inputData = procData.getInputData();

        // Loop through input/output table pairs

        for (int table = 0; table < inputData.getTableCount(); ++table) {

            ProcData.InputTable inputTable = procData.getInputData().getTable(table);
            ProcData.OutputTable outputTable = procData.getOutputData().getTable(table);
            ProcData.OutputColumn outputColumn = outputTable.getColumn(1);

            // Set the output table size

            long recordCount = inputTable.getSize();

            outputTable.setSize(recordCount);

            ProcData.InputColumn inputIdColumn = inputTable.getColumn(0);
            ProcData.OutputColumn outputIdColumn = outputTable.getColumn(0);

            // For every record in the input table, copy the ID values to output ID column
            // Square the input columns, add them together, then copy the values to the other output column

            for (int row = 0; row < recordCount; ++row) {
                outputIdColumn.appendShort(inputIdColumn.getShort(row));
                double sos = Math.pow(inputTable.getColumn(1).getFloat(row), 2) +
                  Math.pow(inputTable.getColumn(2).getFloat(row), 2);
                outputColumn.appendFloat((float)sos);
            }
        }

        procData.complete();
    }
}
